/*
 * blanco Framework
 * Copyright (C) 2004-2006 IGA Tosiki
 * 
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 */
package blanco.test.db.ddl;

/**
 * {vOblancoDb̎ڂ̂AP\Ɋւ鎎{邽߂̃[eBeBłB
 * 
 * 1̗񂪊܂܂ꂽ\ΏۂƂȂ܂B<br>
 * ̃vO SQL Server 2000pDDL𐶐܂B
 */
public class SimpleTableSQLServer2000DoubleColumnDDL {
    public static final String[] TYPES = { "BIGINT", "BINARY(50)", "BIT",
            "CHAR(10)", "DATETIME", "DECIMAL(18, 3)", "FLOAT", "IMAGE", "INT",
            "MONEY", "NCHAR(10)", "NTEXT", "NUMERIC", "NVARCHAR(10)", "REAL",
            "SMALLDATETIME", "SMALLINT", "SMALLMONEY", "TEXT", "TIMESTAMP",
            "TINYINT", "UNIQUEIDENTIFIER", "VARBINARY", "VARCHAR" };

    /**
     * DDL̍쐬s܂B
     * 
     * @param args
     *            Bw肳ꂽe͖܂B
     */
    public static void main(final String[] args) {
        System.out.println("------------------------------------------");
        System.out.println("-- 폜GAłB --");
        System.out.println("------------------------------------------");

        generateDeleteDoubleColumnPrimary1();
        generateDeleteDoubleColumnPrimary2();
        generateDeleteDoubleColumnPrimary3();
        generateDeleteDoubleColumnNonPrimary();
        generateDeleteDoubleColumnPrimary1Nullable();
        generateDeleteDoubleColumnPrimary2Nullable();
        generateDeleteDoubleColumnPrimary3Nullable();
        generateDeleteDoubleColumnNonPrimaryNullable();

        System.out.println("------------------------------------------");
        System.out.println("-- 琶GAłB --");
        System.out.println("------------------------------------------");

        generateDoubleColumnPrimary1();
        generateDoubleColumnPrimary2();
        generateDoubleColumnPrimary3();
        generateDoubleColumnNonPrimary();
        generateDoubleColumnPrimary1Nullable();
        generateDoubleColumnPrimary2Nullable();
        generateDoubleColumnPrimary3Nullable();
        generateDoubleColumnNonPrimaryNullable();
    }

    private static final void generateDoubleColumnPrimary1() {
        System.out.println("------------------------------------------");
        System.out.println("-- 2̍ڂŁA1ڂ̃vC}L[ɂ\쐬܂B");
        System.out.println("------------------------------------------");
        System.out.println("");

        for (int index = 0; index < TYPES.length; index++) {
            final int spacePosition = TYPES[index].indexOf("(");
            String fieldName = TYPES[index];
            if (spacePosition >= 0) {
                fieldName = fieldName.substring(0, spacePosition);
            }

            if ("IMAGE".equals(TYPES[index]) || "NTEXT".equals(TYPES[index])
                    || "TEXT".equals(TYPES[index])) {
                System.out.println("-- " + TYPES[index]
                        + "^̓vC}L[Ƃ邱Ƃ͂ł܂B");
                System.out.println("");
                continue;
            }

            System.out.println("/*2̍ڂŁA1ڂvC}L[̕\𐶐܂B(" + TYPES[index]
                    + ")*/");
            System.out.println("CREATE TABLE TEST_DOUBLE_COLUMN_PRIMARY1_"
                    + (index + 1) + " (");
            System.out.println("FIELD_" + fieldName + " " + TYPES[index]
                    + " NOT NULL");
            System.out.println(", FIELD_VARCHAR_FIXED VARCHAR(50) NOT NULL");
            System.out.println(", PRIMARY KEY (FIELD_" + fieldName + ")");
            System.out.println(");");
            System.out.println("");
        }
    }

    private static final void generateDoubleColumnPrimary2() {
        System.out.println("------------------------------------------");
        System.out.println("-- 2̍ڂŁA2ڂ̃vC}L[ɂ\쐬܂B");
        System.out.println("------------------------------------------");
        System.out.println("");

        for (int index = 0; index < TYPES.length; index++) {
            final int spacePosition = TYPES[index].indexOf("(");
            String fieldName = TYPES[index];
            if (spacePosition >= 0) {
                fieldName = fieldName.substring(0, spacePosition);
            }

            System.out.println("/*2̍ڂŁA2ڂvC}L[̕\𐶐܂B(" + TYPES[index]
                    + ")*/");
            System.out.println("CREATE TABLE TEST_DOUBLE_COLUMN_PRIMARY2_"
                    + (index + 1) + " (");
            System.out.println("FIELD_" + fieldName + " " + TYPES[index]
                    + " NOT NULL");
            System.out.println(", FIELD_VARCHAR_FIXED VARCHAR(50) NOT NULL");
            System.out.println(", PRIMARY KEY (FIELD_VARCHAR_FIXED)");
            System.out.println(");");
            System.out.println("");
        }
    }

    private static final void generateDoubleColumnPrimary3() {
        System.out.println("------------------------------------------");
        System.out.println("-- 2̍ڂŁA2ƂvC}L[ł\쐬܂B");
        System.out.println("------------------------------------------");
        System.out.println("");

        for (int index = 0; index < TYPES.length; index++) {
            final int spacePosition = TYPES[index].indexOf("(");
            String fieldName = TYPES[index];
            if (spacePosition >= 0) {
                fieldName = fieldName.substring(0, spacePosition);
            }

            if ("IMAGE".equals(TYPES[index]) || "NTEXT".equals(TYPES[index])
                    || "TEXT".equals(TYPES[index])) {
                System.out.println("-- " + TYPES[index]
                        + "^̓vC}L[Ƃ邱Ƃ͂ł܂B");
                System.out.println("");
                continue;
            }

            System.out.println("/*2̍ڂŁAƂvC}L[̕\𐶐܂B(" + TYPES[index]
                    + ")*/");
            System.out.println("CREATE TABLE TEST_DOUBLE_COLUMN_PRIMARY3_"
                    + (index + 1) + " (");
            System.out.println("FIELD_" + fieldName + " " + TYPES[index]
                    + " NOT NULL");
            System.out.println(", FIELD_VARCHAR_FIXED VARCHAR(50) NOT NULL");
            System.out.println(", PRIMARY KEY (FIELD_" + fieldName
                    + ", FIELD_VARCHAR_FIXED)");
            System.out.println(");");
            System.out.println("");
        }
    }

    private static final void generateDoubleColumnNonPrimary() {
        System.out.println("------------------------------------------");
        System.out.println("-- 2̍ڂŁA2ƂvC}L[łȂ\쐬܂B");
        System.out.println("------------------------------------------");
        System.out.println("");

        for (int index = 0; index < TYPES.length; index++) {
            final int spacePosition = TYPES[index].indexOf("(");
            String fieldName = TYPES[index];
            if (spacePosition >= 0) {
                fieldName = fieldName.substring(0, spacePosition);
            }

            System.out.println("/*2̍ڂŁAƂvC}L[łȂ\𐶐܂B("
                    + TYPES[index] + ")*/");
            System.out.println("CREATE TABLE TEST_DOUBLE_COLUMN_NON_PRIMARY_"
                    + (index + 1) + " (");
            System.out.println("FIELD_" + fieldName + " " + TYPES[index]
                    + " NOT NULL");
            System.out.println(", FIELD_VARCHAR_FIXED VARCHAR(50) NOT NULL");
            System.out.println(");");
            System.out.println("");
        }
    }

    private static final void generateDoubleColumnPrimary1Nullable() {
        System.out.println("------------------------------------------");
        System.out.println("-- 2nulleȍڂŁA1ڂvC}L[ł\쐬܂B");
        System.out.println("------------------------------------------");
        System.out.println("");

        for (int index = 0; index < TYPES.length; index++) {
            final int spacePosition = TYPES[index].indexOf("(");
            String fieldName = TYPES[index];
            if (spacePosition >= 0) {
                fieldName = fieldName.substring(0, spacePosition);
            }

            if ("IMAGE".equals(TYPES[index]) || "NTEXT".equals(TYPES[index])
                    || "TEXT".equals(TYPES[index])) {
                System.out.println("-- " + TYPES[index]
                        + "^̓vC}L[Ƃ邱Ƃ͂ł܂B");
                System.out.println("");
                continue;
            }

            System.out.println("/*2nulleȍڂŁA1ڂvC}L[̕\𐶐܂B("
                    + TYPES[index] + ")*/");
            System.out.println("CREATE TABLE TEST_DOUBLE_COLUMN_PRIMARY1_"
                    + (index + 1) + "_NULLABLE (");
            System.out.println("FIELD_" + fieldName + " " + TYPES[index]);
            System.out.println(", FIELD_VARCHAR_FIXED VARCHAR(50)");
            System.out.println(", PRIMARY KEY (FIELD_" + fieldName + ")");
            System.out.println(");");
            System.out.println("");
        }
    }

    private static final void generateDoubleColumnPrimary2Nullable() {
        System.out.println("------------------------------------------");
        System.out.println("-- 2nulleȍڂŁA2ڂvC}L[ł\쐬܂B");
        System.out.println("------------------------------------------");
        System.out.println("");

        for (int index = 0; index < TYPES.length; index++) {
            final int spacePosition = TYPES[index].indexOf("(");
            String fieldName = TYPES[index];
            if (spacePosition >= 0) {
                fieldName = fieldName.substring(0, spacePosition);
            }

            System.out.println("/*2nulleȍڂŁA2ڂvC}L[̕\𐶐܂B("
                    + TYPES[index] + ")*/");
            System.out.println("CREATE TABLE TEST_DOUBLE_COLUMN_PRIMARY2_"
                    + (index + 1) + "_NULLABLE (");
            System.out.println("FIELD_" + fieldName + " " + TYPES[index]);
            System.out.println(", FIELD_VARCHAR_FIXED VARCHAR(50)");
            System.out.println(", PRIMARY KEY (FIELD_VARCHAR_FIXED)");
            System.out.println(");");
            System.out.println("");
        }
    }

    private static final void generateDoubleColumnPrimary3Nullable() {
        System.out.println("------------------------------------------");
        System.out.println("-- 2nulleȍڂŁA2ƂvC}L[ł\쐬܂B");
        System.out.println("------------------------------------------");
        System.out.println("");

        for (int index = 0; index < TYPES.length; index++) {
            final int spacePosition = TYPES[index].indexOf("(");
            String fieldName = TYPES[index];
            if (spacePosition >= 0) {
                fieldName = fieldName.substring(0, spacePosition);
            }

            if ("IMAGE".equals(TYPES[index]) || "NTEXT".equals(TYPES[index])
                    || "TEXT".equals(TYPES[index])) {
                System.out.println("-- " + TYPES[index]
                        + "^̓vC}L[Ƃ邱Ƃ͂ł܂B");
                System.out.println("");
                continue;
            }

            System.out.println("/*2nulleȍڂŁAƂvC}L[̕\𐶐܂B("
                    + TYPES[index] + ")*/");
            System.out.println("CREATE TABLE TEST_DOUBLE_COLUMN_PRIMARY3_"
                    + (index + 1) + "_NULLABLE (");
            System.out.println("FIELD_" + fieldName + " " + TYPES[index]);
            System.out.println(", FIELD_VARCHAR_FIXED VARCHAR(50)");
            System.out.println(", PRIMARY KEY (FIELD_" + fieldName
                    + ", FIELD_VARCHAR_FIXED)");
            System.out.println(");");
            System.out.println("");
        }
    }

    private static final void generateDoubleColumnNonPrimaryNullable() {
        System.out.println("------------------------------------------");
        System.out.println("-- 2nulleȍڂŁA2ƂvC}L[łȂ\쐬܂B");
        System.out.println("------------------------------------------");
        System.out.println("");

        for (int index = 0; index < TYPES.length; index++) {
            final int spacePosition = TYPES[index].indexOf("(");
            String fieldName = TYPES[index];
            if (spacePosition >= 0) {
                fieldName = fieldName.substring(0, spacePosition);
            }

            System.out.println("/*2nulleȍڂŁAƂvC}L[łȂ\𐶐܂B("
                    + TYPES[index] + ")*/");
            System.out.println("CREATE TABLE TEST_DOUBLE_COLUMN_NON_PRIMARY_"
                    + (index + 1) + "_NULLABLE (");
            System.out.println("FIELD_" + fieldName + " " + TYPES[index]);
            System.out.println(", FIELD_VARCHAR_FIXED VARCHAR(50)");
            System.out.println(");");
            System.out.println("");
        }
    }

    // ͍폜GAłB
    // 폜pDDL𐶐܂B

    private static final void generateDeleteDoubleColumnPrimary1() {
        System.out.println("------------------------------------------");
        System.out.println("-- 2̍ڂŁA1ڂ̃vC}L[ɂ\폜܂B");
        System.out.println("------------------------------------------");
        System.out.println("");

        for (int index = 0; index < TYPES.length; index++) {
            final int spacePosition = TYPES[index].indexOf("(");
            String fieldName = TYPES[index];
            if (spacePosition >= 0) {
                fieldName = fieldName.substring(0, spacePosition);
            }

            if ("IMAGE".equals(TYPES[index]) || "NTEXT".equals(TYPES[index])
                    || "TEXT".equals(TYPES[index])) {
                System.out.println("-- " + TYPES[index]
                        + "^̓vC}L[Ƃ邱Ƃ͂ł܂B");
                System.out.println("");
                continue;
            }

            System.out.println("DROP TABLE TEST_DOUBLE_COLUMN_PRIMARY1_"
                    + (index + 1) + ";");
        }
    }

    private static final void generateDeleteDoubleColumnPrimary2() {
        System.out.println("------------------------------------------");
        System.out.println("-- 2̍ڂŁA2ڂ̃vC}L[ɂ\폜܂B");
        System.out.println("------------------------------------------");
        System.out.println("");

        for (int index = 0; index < TYPES.length; index++) {
            final int spacePosition = TYPES[index].indexOf("(");
            String fieldName = TYPES[index];
            if (spacePosition >= 0) {
                fieldName = fieldName.substring(0, spacePosition);
            }

            System.out.println("DROP TABLE TEST_DOUBLE_COLUMN_PRIMARY2_"
                    + (index + 1) + ";");
        }
    }

    private static final void generateDeleteDoubleColumnPrimary3() {
        System.out.println("------------------------------------------");
        System.out.println("-- 2̍ڂŁA2ƂvC}L[ł\폜܂B");
        System.out.println("------------------------------------------");
        System.out.println("");

        for (int index = 0; index < TYPES.length; index++) {
            final int spacePosition = TYPES[index].indexOf("(");
            String fieldName = TYPES[index];
            if (spacePosition >= 0) {
                fieldName = fieldName.substring(0, spacePosition);
            }

            if ("IMAGE".equals(TYPES[index]) || "NTEXT".equals(TYPES[index])
                    || "TEXT".equals(TYPES[index])) {
                System.out.println("-- " + TYPES[index]
                        + "^̓vC}L[Ƃ邱Ƃ͂ł܂B");
                System.out.println("");
                continue;
            }

            System.out.println("DROP TABLE TEST_DOUBLE_COLUMN_PRIMARY3_"
                    + (index + 1) + ";");
        }
    }

    private static final void generateDeleteDoubleColumnNonPrimary() {
        System.out.println("------------------------------------------");
        System.out.println("-- 2̍ڂŁA2ƂvC}L[łȂ\폜܂B");
        System.out.println("------------------------------------------");
        System.out.println("");

        for (int index = 0; index < TYPES.length; index++) {
            final int spacePosition = TYPES[index].indexOf("(");
            String fieldName = TYPES[index];
            if (spacePosition >= 0) {
                fieldName = fieldName.substring(0, spacePosition);
            }

            System.out.println("DROP TABLE TEST_DOUBLE_COLUMN_NON_PRIMARY_"
                    + (index + 1) + ";");
        }
    }

    private static final void generateDeleteDoubleColumnPrimary1Nullable() {
        System.out.println("------------------------------------------");
        System.out.println("-- 2nulleȍڂŁA1ڂvC}L[ł\폜܂B");
        System.out.println("------------------------------------------");
        System.out.println("");

        for (int index = 0; index < TYPES.length; index++) {
            final int spacePosition = TYPES[index].indexOf("(");
            String fieldName = TYPES[index];
            if (spacePosition >= 0) {
                fieldName = fieldName.substring(0, spacePosition);
            }

            if ("IMAGE".equals(TYPES[index]) || "NTEXT".equals(TYPES[index])
                    || "TEXT".equals(TYPES[index])) {
                System.out.println("-- " + TYPES[index]
                        + "^̓vC}L[Ƃ邱Ƃ͂ł܂B");
                System.out.println("");
                continue;
            }

            System.out.println("DROP TABLE TEST_DOUBLE_COLUMN_PRIMARY1_"
                    + (index + 1) + "_NULLABLE;");
        }
    }

    private static final void generateDeleteDoubleColumnPrimary2Nullable() {
        System.out.println("------------------------------------------");
        System.out.println("-- 2nulleȍڂŁA2ڂvC}L[ł\폜܂B");
        System.out.println("------------------------------------------");
        System.out.println("");

        for (int index = 0; index < TYPES.length; index++) {
            final int spacePosition = TYPES[index].indexOf("(");
            String fieldName = TYPES[index];
            if (spacePosition >= 0) {
                fieldName = fieldName.substring(0, spacePosition);
            }

            System.out.println("DROP TABLE TEST_DOUBLE_COLUMN_PRIMARY2_"
                    + (index + 1) + "_NULLABLE;");
        }
    }

    private static final void generateDeleteDoubleColumnPrimary3Nullable() {
        System.out.println("------------------------------------------");
        System.out.println("-- 2nulleȍڂŁA2ƂvC}L[ł\폜܂B");
        System.out.println("------------------------------------------");
        System.out.println("");

        for (int index = 0; index < TYPES.length; index++) {
            final int spacePosition = TYPES[index].indexOf("(");
            String fieldName = TYPES[index];
            if (spacePosition >= 0) {
                fieldName = fieldName.substring(0, spacePosition);
            }

            if ("IMAGE".equals(TYPES[index]) || "NTEXT".equals(TYPES[index])
                    || "TEXT".equals(TYPES[index])) {
                System.out.println("-- " + TYPES[index]
                        + "^̓vC}L[Ƃ邱Ƃ͂ł܂B");
                System.out.println("");
                continue;
            }

            System.out.println("DROP TABLE TEST_DOUBLE_COLUMN_PRIMARY3_"
                    + (index + 1) + "_NULLABLE;");
        }
    }

    private static final void generateDeleteDoubleColumnNonPrimaryNullable() {
        System.out.println("------------------------------------------");
        System.out.println("-- 2nulleȍڂŁA2ƂvC}L[łȂ\폜܂B");
        System.out.println("------------------------------------------");
        System.out.println("");

        for (int index = 0; index < TYPES.length; index++) {
            final int spacePosition = TYPES[index].indexOf("(");
            String fieldName = TYPES[index];
            if (spacePosition >= 0) {
                fieldName = fieldName.substring(0, spacePosition);
            }

            System.out.println("DROP TABLE TEST_DOUBLE_COLUMN_NON_PRIMARY_"
                    + (index + 1) + "_NULLABLE;");
        }
    }
}
